/// <reference path="jquery.d.ts"/>
var lib;
(function (lib) {
    (function (lib_button) {
        /**
        * BaseButton
        */
        var BaseButton = (function () {
            function BaseButton(id, target) {
                this.isActive = false;
                this.isCurrent = false;
                this.id = id;
                this.$target = target;
                this.$target.css({ cursor: "default" });

                //
                var scope = this;
                this.$target.on("click", function (e) {
                    scope.onClick(e);
                });
                this.$target.on("mouseenter", function (e) {
                    scope.onOver(e);
                });
                this.$target.on("mouseleave", function (e) {
                    scope.onOut(e);
                });
            }
            BaseButton.prototype.init = function () {
            };

            BaseButton.prototype.getId = function () {
                return this.id;
            };

            BaseButton.prototype.setActive = function () {
                if (this.isActive) {
                    return;
                }
                this.isActive = true;
                this.$target.css({ cursor: "pointer" });
            };

            BaseButton.prototype.deleteActive = function () {
                if (!this.isActive) {
                    return;
                }
                this.isActive = false;
                this.$target.css({ cursor: "default" });
            };

            BaseButton.prototype.setCurrent = function () {
                if (this.isCurrent) {
                    return;
                }
                this.isCurrent = true;
                this.$target.addClass("current");
                this.$target.removeClass("over");
            };

            BaseButton.prototype.deleteCurrent = function () {
                if (!this.isCurrent) {
                    return;
                }
                this.isCurrent = false;
                this.$target.removeClass("current");
                this.$target.removeClass("over");
            };

            BaseButton.prototype.onOver = function (e) {
                if (!this.isCurrent && this.isActive) {
                    this.$target.addClass("over");
                }
            };

            BaseButton.prototype.onOut = function (e) {
                if (!this.isCurrent && this.isActive) {
                    this.$target.removeClass("over");
                }
            };

            BaseButton.prototype.onClick = function (e) {
                e.preventDefault();
                if (this.isActive) {
                    console.log("_onClick : " + this.id);
                }
            };
            return BaseButton;
        })();
        lib_button.BaseButton = BaseButton;
    })(lib.lib_button || (lib.lib_button = {}));
    var lib_button = lib.lib_button;
    (function (lib_display) {
        /**
        * BaseDisplay
        */
        var BaseDisplay = (function () {
            function BaseDisplay(id, target) {
                this.isOpen = false;
                this.id = id;
                this.$target = target;
                this.$target.css({ display: "none" });
            }
            BaseDisplay.prototype.init = function () {
            };

            BaseDisplay.prototype.getId = function () {
                return this.id;
            };

            BaseDisplay.prototype.open = function () {
                if (this.isOpen) {
                    return;
                }
                this.isOpen = true;
                this.onOpen();
            };

            BaseDisplay.prototype.onOpen = function () {
                this.$target.css({ display: "block" });
                this.completeOpen();
            };

            BaseDisplay.prototype.completeOpen = function () {
            };

            BaseDisplay.prototype.close = function () {
                if (!this.isOpen) {
                    return;
                }
                this.isOpen = false;
                this.onClose();
            };

            BaseDisplay.prototype.onClose = function () {
                this.$target.css({ display: "none" });
                this.completeClose();
            };

            BaseDisplay.prototype.completeClose = function () {
            };
            return BaseDisplay;
        })();
        lib_display.BaseDisplay = BaseDisplay;
    })(lib.lib_display || (lib.lib_display = {}));
    var lib_display = lib.lib_display;
})(lib || (lib = {}));
//# sourceMappingURL=lib.js.map
